/*
 * OZ711MS1 OZ711MP1 linux driver
 * O2Micro Inc.
 * toby.yang@o2micro.com
 * 2005/4/17
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _SCSI_O2MEDIA_H_
#define _SCSI_O2MEDIA_H_

#include "base.h"
#include "basic.h"
#include "scsi_base.h"
struct t_o2media_pri_data {
int ko2media_cmd_control_pid; // pid of thread handling scsi command from system scsi layer.
struct scsi_cmnd* cur_srb; // current scsi srb.
struct scsi_cmnd* que_srb; // the queued scsi srb.
struct completion notify;
spinlock_t cmd_lock;
spinlock_t srb_lock;
wait_queue_head_t o2media_cmd_control_event;
unsigned char o2media_cmd_comming;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
Scsi_Host_Template *po2media_myht;
#else
struct Scsi_Host *o2media_sh;
struct scsi_host_template *po2media_myht;
#endif
unsigned char* buffer;
unsigned long buffer_size;
};
extern struct t_o2media_pri_data o2media_pri_data;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
extern Scsi_Host_Template o2media_host_template;
#else
extern struct scsi_host_template o2media_host_template;
#endif
BOOLEAN o2media_device_reset();
BOOLEAN o2media_bus_reset();
void o2media_preUnInit();
BOOLEAN o2media_cmd_abort();
BOOLEAN o2media_check_intr();
BOOLEAN o2media_host_reset(unsigned long devext_addr);
int o2media_inquiry(INQUIRY_DATA* inquiry,unsigned long devext_addr);
int o2media_testunitready(unsigned long devext_addr);
int o2media_requestsense(SENSE_DATA *senseBuffer,unsigned long devext_addr);
int o2media_modesense(MODE_PAGE_DATA* mdata,BOOLEAN mdata_3f,unsigned long devext_addr);
int  o2media_allowmediumremoval(ULONG devext_addr);
int o2media_readcapacity(READ_CAPACITY_DATA* capacityData,ULONG devext_addr);
int	o2media_readData(PUCHAR currentBuf,ULONG startBlock,ULONG blockCount,ULONG devext_addr);
int	o2media_writeData(PUCHAR currentBuf,ULONG startBlock,ULONG blockCount,ULONG devext_addr);
BOOLEAN o2media_interrupt();
BOOLEAN o2media_SCIInitialize(ULONG m_o2media_base,unsigned long m_devExt);
#endif
